Public Class Ball
    Public Property MyShape As Shape
    Public Property Transform As TranslateTransform
    Public Property Vx As Double
    Public Property Vy As Double
    Public Property Bounds As Rect

    ' Constructor.
    Public Sub New(ByVal new_shape As Shape,
        ByVal initial_transform As TranslateTransform,
        ByVal initial_vx As Double, ByVal initial_vy As Double,
        ByVal the_bounds As Rect)

        MyShape = new_shape
        Transform = initial_transform
        Vx = initial_vx
        Vy = initial_vy
        Bounds = the_bounds
    End Sub

    ' Update our position for the elapsed time.
    Public Sub Update(ByVal elapsed As TimeSpan)
        Dim x As Double = Transform.X + Vx * elapsed.TotalSeconds
        If ((Vx < 0) AndAlso (x < Bounds.Left)) Then
            ' We hit the left wall.
            Vx = -Vx
            x += 2 * (Bounds.Left - x)
        ElseIf ((Vx > 0) AndAlso (x + MyShape.Width > Bounds.Right)) Then
            ' We hit the right wall.
            Vx = -Vx
            x -= 2 * (x + MyShape.Width - Bounds.Right)
        End If

        Dim y As Double = Transform.Y + Vy * elapsed.TotalSeconds
        If ((Vy < 0) AndAlso (y < Bounds.Top)) Then
            ' We hit the top wall.
            Vy = -Vy
            y += 2 * (Bounds.Top - y)
        ElseIf ((Vy > 0) AndAlso (y + MyShape.Width > Bounds.Bottom)) Then
            ' We hit the bottom wall.
            Vy = -Vy
            y -= 2 * (y + MyShape.Width - Bounds.Bottom)
        End If

        Transform.X = x
        Transform.Y = y
    End Sub
End Class
